package net.roseindia.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.sun.org.apache.regexp.internal.recompile;

import net.roseindia.model.SearchModel;
import net.roseindia.model.StudentAdmissionModel;

public class ApplicationDAO {

	Connection connection = null;
	PreparedStatement ptmt = null;
	ResultSet rs = null;

	public ApplicationDAO() {	}
	
	private Connection getConnection() throws SQLException {
		java.sql.Connection con;
		con = ConnectionFactory.getInstance().getConnection();
		return con;
	}
	
	public int add(StudentAdmissionModel studentAddmission) {
		int rollnum = 0;
		try {
			String queryString = "INSERT INTO stud_admission(s_name, f_name, dob, c_date, class1, address, phoneno, fee) VALUES(?,?,?,?,?,?,?,?)";
			connection = getConnection();
			ptmt = connection.prepareStatement(queryString);
			ptmt.setString(1, studentAddmission.getName());
			ptmt.setString(2, studentAddmission.getFname());
			ptmt.setString(3, studentAddmission.getDob());
			ptmt.setString(4, studentAddmission.getCurrentDate());
			ptmt.setString(5, studentAddmission.getClass1());
			ptmt.setString(6, studentAddmission.getAddress());
			ptmt.setString(7, studentAddmission.getPhoneno());
			ptmt.setLong(8, studentAddmission.getFee());
			ptmt.executeUpdate();
			String query = "select max(roll_no) from stud_admission";
			System.out.println(query);
			ResultSet rs = ptmt.executeQuery(query);
			System.out.println("Result Set" + rs);
			while (rs.next()) {
				rollnum = rs.getInt(1);
				System.out.println(rollnum);
			}
			System.out.println("Data Added Successfully");

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try {
				if (ptmt != null)
					ptmt.close();
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}

		}
		return rollnum;
	}

	public StudentAdmissionModel search(SearchModel model) {
		StudentAdmissionModel student = new StudentAdmissionModel();
		String query;
		query = "select * from stud_admission where s_name='"
				+ model.getS_name() + "' or roll_no='" + model.getS_roll()
				+ "' or class1='" + model.getCalss1() + "'";
		//System.out.println(query);
		try {
			connection = getConnection();
			
			ptmt = connection.prepareStatement(query);
			rs = ptmt.executeQuery(query);			
			while (rs.next()) {
				student.setName(rs.getString("s_name"));
				student.setFname(rs.getString("f_name"));
				student.setDob(rs.getString("dob"));
				student.setCurrentDate(rs.getString("c_date"));
				student.setClass1(rs.getString("class1"));
				student.setAddress(rs.getString("address"));
				student.setPhoneno(rs.getString("phoneno"));
				student.setFee(rs.getLong("fee"));
				student.setRoll(rs.getInt("roll_no"));
				System.out.println("HEllokdkf" + query);
			}
		} catch (Exception e) {
			e.toString();
		} finally {
			try {
				if (ptmt != null)
					ptmt.close();
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return student;
	}

	public StudentAdmissionModel search(int roll) {
		try {
			connection = getConnection();

			StudentAdmissionModel model = new StudentAdmissionModel();

			String query = "select * from stud_admission where roll_no='"
					+ roll + "'";
			System.out.println("Update Search Querey : " + query);
			ptmt = connection.prepareStatement(query);
			rs = ptmt.executeQuery();
			while (rs.next()) {

				model.setName(rs.getString("s_name"));
				System.out.println("Student Name : " + model.getName());
				model.setFname(rs.getString("f_name"));
				model.setDob(rs.getString("dob"));
				model.setCurrentDate(rs.getString("c_date"));
				model.setClass1(rs.getString("class1"));
				model.setAddress(rs.getString("address"));
				model.setPhoneno(rs.getString("phoneno"));
				model.setFee(rs.getLong("fee"));
				model.setRoll(rs.getInt("roll_no"));
			}
			return model;
		} catch (Exception e) {
			e.toString();
		} finally {
			try {
				if (ptmt != null)
					ptmt.close();
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	public StudentAdmissionModel search1(String sRoll) {
		StudentAdmissionModel onbupdateModel = new StudentAdmissionModel();
		try {
			connection = getConnection();
			System.out.println("Conn...... " +connection);
			String query = "select * from stud_admission where roll_no=?";
			ptmt = connection.prepareStatement(query);
			ptmt.setString(1, sRoll);
			ResultSet rs = ptmt.executeQuery();
			while (rs.next()) {
				
				onbupdateModel.setRoll(rs.getInt(1));
				onbupdateModel.setName(rs.getString(2));
				onbupdateModel.setFname(rs.getString(3));
				onbupdateModel.setDob(rs.getString(4));
				onbupdateModel.setCurrentDate(rs.getString(5));
				onbupdateModel.setClass1(rs.getString(6));
				onbupdateModel.setAddress(rs.getString(7));
				onbupdateModel.setPhoneno(rs.getString(8));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return onbupdateModel;
	}

	public void delete(int roll) {
		try {
			connection = getConnection();
			String query = "delete from stud_admission where roll_no=?";
			ptmt = connection.prepareStatement(query);
			ptmt.setInt(1, roll);
			ptmt.executeUpdate();
			System.out.println("Rocord deleted");
		} catch (Exception e) {
			e.toString();
		} finally {
			try {
				if (ptmt != null)
					ptmt.close();
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	public StudentAdmissionModel update(StudentAdmissionModel model) {
		PreparedStatement	ptmt1=null;
		String query = "UPDATE stud_admission SET s_name=?, f_name=?, dob=?, c_date=?, class1=?, address=?, phoneno=?, fee=? where roll_no=?";
		String queryAftUpdate="select * from stud_admission where roll_no=?";
		try {
			connection = getConnection();
			ptmt1= connection.prepareStatement(query);
			ptmt1.setString(1,model.getName());
			ptmt1.setString(2, model.getFname());
			ptmt1.setString(3, model.getDob());
			ptmt1.setString(4, model.getCurrentDate());
			ptmt1.setString(5, model.getClass1());
			ptmt1.setString(6, model.getAddress());
			ptmt1.setString(7, model.getPhoneno());
			ptmt1.setLong(8, model.getFee());
			System.out.println("Roll : "+ model.getRoll());
			ptmt1.setInt(9, model.getRoll());
			System.out.println(query);
			int b = ptmt1.executeUpdate();		
			System.out.println("Table Updated Suucessfully");
			ptmt1= connection.prepareStatement(queryAftUpdate);
			ptmt1.setInt(1,model.getRoll());
			
		ResultSet rs=ptmt1.executeQuery();
		while(rs.next())
		{
			model.setRoll(rs.getInt(1));
			model.setName(rs.getString(2));
			model.setFname(rs.getString(3));
			model.setDob(rs.getString(4));
			model.setCurrentDate(rs.getString(5));
			model.setClass1(rs.getString(6));
			model.setAddress(rs.getString(7));
			model.setPhoneno(rs.getString(8));
			model.setFee(rs.getInt(9));
		}
			
		} catch (Exception e) {
			e.toString();
		} finally {
			try {
				if (ptmt1 != null)
					ptmt1.close();
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return model;
	}

}
